unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, NetWorks, MyNetWorks, XPMan, ComCtrls, ImgList,
  ExtCtrls;

type
  TMain = class(TForm)
    Button1: TButton;
    NW: TMyNetWorks;
    I32: TImageList;
    Tree: TTreeView;
    XPMan: TXPManifest;
    Panel1: TPanel;
    User: TEdit;
    Comp: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    BegDat: TLabel;
    EndDat: TLabel;
    Label5: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    function  FindGrp( g: TTreeNode; gID: integer ): TTreeNode;
    function  GetGID( str: string ): integer;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Main: TMain;

implementation

{$R *.dfm}

procedure TMain.Button1Click(Sender: TObject);
var
   d, c, g, u, s:     TThreadList;
   nComp, nDom, nSh:  TTreeNode;
   gCmp, gGrp, gUsr:  TTreeNode;
   i, j, k, l, m:     cardinal;
   pdc:               string;
   pns:               PMyNetSrv;
   ggg:               TTreeNode;
   tmpS:              string;
   q:                 cardinal;
begin
   BegDat.Caption := TimeToStr(Now);
   d := nil; c := nil; g := nil; u := nil; s := nil;

   Tree.Items.Clear;

   // Domains
   try
      d := NW.GetDomains;
      if Assigned( d ) then
         with d.LockList do begin
            if Count > 0 then
               for i := 0 to Count - 1 do begin
                  // Adding a domin name
                  nDom := Tree.Items.Add( nil, PMyNetResource( Items[i] )^.RemoteName+' (Comment: '+PMyNetResource( Items[i] )^.Comment+') (Provider: '+PMyNetResource( Items[i] )^.Provider+')' );
                  nDom.ImageIndex := 0;
                  nDom.SelectedIndex := 0;
                  nDom.StateIndex := 0;

                  gCmp := Tree.Items.AddChild( nDom, '' );
                  gCmp.ImageIndex := 11;
                  gCmp.SelectedIndex := 11;
                  gCmp.StateIndex := 11;

                  gGrp := Tree.Items.AddChild( nDom, ' ' );
                  gGrp.ImageIndex := 4;
                  gGrp.SelectedIndex := 4;
                  gGrp.StateIndex := 4;

                  // Get PDC to access many other information
                  try
                  c := NW.GetPDC( PMyNetResource( Items[i] )^.RemoteName );
                  if Assigned( c ) then
                     with c.LockList do
                        try
                           if Count = 1 then
                              pdc := PMyNetResource(Items[0])^.RemoteName;
                              if pdc <>''then begin

                                 // Groups
                                 try
                                    g := NW.GetGroups( pdc );
                                    if Assigned( g ) then begin
                                       with g.LockList do
                                          if Count > 0 then
                                             for l := 0 to Count - 1 do begin
                                                nComp := Tree.Items.AddChild( gGrp, '|'+IntToStr(PMyNetGroup(Items[l])^.gID)+'| '+PMyNetGroup(Items[l])^.Name+' ('+PMyNetGroup(Items[l])^.Comment+')' );
                                                nComp.ImageIndex := 9;
                                                nComp.SelectedIndex := 9;
                                                nComp.StateIndex := 9;
                                             end;
                                    end;
                                 finally
                                    NW.FreeAndNilList( g );
                                 end;

                                 //Users. If You want to obtain computers accounts too, You need
                                 //remove FILTER_NORMAL_ACCOUNT from function all below or set
                                 // suggested filter from _NetC.inc. Use FILTER_ALL_ACCOUNT for
                                 // obtain all accounts (Users and Computers)
                                 try
                                    u := NW.GetUsers( pdc, FILTER_NORMAL_ACCOUNT );
                                    if Assigned( u ) then begin
                                       with u.LockList do begin
                                          if Count > 0 then
                                             for l := 0 to Count - 1 do begin

                                                if Assigned( PMyNetUser(Items[l])^.Groups ) then begin
                                                   if PMyNetUser(Items[l])^.Groups.Count > 0 then begin
                                                      tmpS := 'Grp:';
                                                      for q := 0 to PMyNetUser(Items[l])^.Groups.Count - 1 do
                                                         tmpS := tmpS + '['+PMyGrpName( PMyNetUser(Items[l])^.Groups.Items[q] )^.Name+']';
                                                   end;
                                                   NW.FreeAndNilTList( PMyNetUser(Items[l])^.Groups );
                                                end;

                                                // Users will be added to his primary group only. (PMyNetUser(Items[l])^.gID)
                                                // But You can analize PMyNetUser(Items[l])^.Groups.Items[q] above
                                                // to sort users to all groups they belong
                                                ggg := FindGrp( gGrp, PMyNetUser(Items[l])^.gID );
                                                if Assigned( ggg ) then
                                                   gUsr := Tree.Items.AddChild( ggg, PMyNetUser(Items[l])^.Login+' ('+PMyNetUser(Items[l])^.Name+') '+tmpS )
                                                else
                                                   gUsr := Tree.Items.AddChild( gGrp, PMyNetUser(Items[l])^.Login+' ('+PMyNetUser(Items[l])^.Name+') '+tmpS );

                                                gUsr.ImageIndex := 5;
                                                gUsr.SelectedIndex := 5;
                                                gUsr.StateIndex := 5;
                                             end;
                                          u.UnlockList;
                                       end;
                                    end;
                                 finally
                                    NW.FreeAndNilList( g );
                                 end;

                              end
                        finally
                           c.UnlockList;
                        end;
                  finally
                     NW.FreeAndNilList( c );
                  end;

                  try
                     c := NW.GetServers( pdc, PMyNetResource( Items[i] )^.RemoteName );
                     if Assigned( c ) then
                        with c.LockList do begin
                           if Count > 0 then
                              for j := 0 to Count - 1 do begin
                                 pns := Items[j];
                                 // Adding a computer name
                                 nComp := Tree.Items.AddChild( gCmp, pns^.Name+' ('+pns^.Comment+')' );
                                 if (pns^.Tip and SV_TYPE_DOMAIN_CTRL <> 0) then begin
                                    nComp.ImageIndex := 12;
                                    nComp.SelectedIndex := 12;
                                    nComp.StateIndex := 12;
                                 end
                                 // look for OS (simply)
                                 else if (pns^.Tip and SV_TYPE_WINDOWS <> 0) then begin
                                    nComp.ImageIndex := 2;
                                    nComp.SelectedIndex := 2;
                                    nComp.StateIndex := 2;
                                 end
                                 else if (pns^.Tip and SV_TYPE_NT <> 0) then begin
                                    nComp.ImageIndex := 1;
                                    nComp.SelectedIndex := 1;
                                    nComp.StateIndex := 1;
                                 end
                                 else if (pns^.Tip and SV_TYPE_WFW <> 0) then begin
                                    nComp.ImageIndex := 3;
                                    nComp.SelectedIndex := 3;
                                    nComp.StateIndex := 3;
                                 end
                                 else begin
                                    nComp.ImageIndex := 1;
                                    nComp.SelectedIndex := 1;
                                    nComp.StateIndex := 1;
                                 end;


                                 // Shares on computer
                                 try
                                    s := NW.GetShares('\\'+pns^.Name, RESOURCETYPE_ANY );
                                    if Assigned( s ) then
                                       with s.LockList do
                                          if Count > 0 then
                                             for k := 0 to Count - 1 do begin
                                                nSh := Tree.Items.AddChild( nComp,  NW.GetShareFromShareName(PMyNetResource(Items[k])^.RemoteName, False)+' ['+PMyNetResource(Items[k])^.RemotePath+'] ('+PMyNetResource(Items[k])^.Comment+')' );
                                                if PMyNetResource(Items[k])^.Tip = RESOURCETYPE_DISK then begin
                                                   nSh.ImageIndex := 7;
                                                   nSh.SelectedIndex := 7;
                                                   nSh.StateIndex := 7;
                                                end
                                                else if PMyNetResource(Items[k])^.Tip = RESOURCETYPE_PRINT then begin
                                                   nSh.ImageIndex := 8;
                                                   nSh.SelectedIndex := 8;
                                                   nSh.StateIndex := 8;
                                                end;
                                             end;
                                 finally
                                    NW.FreeAndNilList( s );
                                 end;


                              end; {for j := 0 to Count - 1 do begin}
                           c.UnlockList;
                        end; {with d.LockList do begin}
                  finally
                     NW.FreeAndNilList( c );
                  end;



               end; {for i := 0 to Count - 1 do begin}
            d.UnlockList;
         end; {with d.LockList do begin}
   finally
      NW.FreeAndNilList( d );
      EndDat.Caption := TimeToStr(Now);
   end;
end;

function TMain.GetGID( str: string ): integer;
var
   cnt, i, j, qqq:                cardinal;
   sss:                           string;
begin
   Result := -1; cnt := 0; qqq := 0; j := 1;
   SetLength( sss, length( str ) );
   for i := 1 to length(str) do begin
      if Str[i] = '|' then
         inc( qqq )
      else if qqq = 1 then begin
         sss[j] := str[i];
         inc( cnt ); inc( j );
      end;
      
      if qqq >= 2 then begin
         SetLength( sss, cnt );
         Result := StrToIntDef( sss, -1 );
         exit;
      end;
   end;

end;

function TMain.FindGrp( g: TTreeNode; gID: integer ): TTreeNode;
var
   tmp:  TTreeNode;
begin
   Result := nil;
   tmp := g.getFirstChild;
   while Assigned( tmp ) do begin
      if GetGID( tmp.Text ) = gID then begin
         Result := tmp;
         exit;
      end
      else
         tmp := g.GetNextChild( tmp );
   end;
end;

procedure TMain.FormCreate(Sender: TObject);
begin
   User.Text := NW.MyUserName;
   Comp.Text := '\\'+NW.MyComputerName;
   BegDat.Caption := '';
   EndDat.Caption := '';
end;

end.
